import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is a white blood cell. This kind of cell has the job to catch 
 * Truck and remove them from the blood.
 * 
 * @author Michael Kölling
 * @version 0.1
 */
public class Lambo extends Actor
{
    private int score;
    /**
     * Constructor for WhiteCell class.
     */
    public Lambo()
    {
        score = 0;

    }

    /**
     * Act: move up and down when cursor keys are pressed.
     */
    public void act() 
    {
        checkKeyPress();
        checkCollision();

    }

    /**
     * Check whether a keyboard key has been pressed and react if it has.
     */
    private void checkKeyPress()
    {
        if (Greenfoot.isKeyDown("up")) 
        {
            setLocation(getX(), getY()-4);
            
        }

        if (Greenfoot.isKeyDown("down")) 
        {
            setLocation(getX(), getY()+4);
        }

        if (Greenfoot.isKeyDown("left"))
        {
            setLocation(getX()-4, getY());
        }

        if (Greenfoot.isKeyDown("right"))
        {
            setLocation(getX()+4, getY());
            Greenfoot.playSound("Rev.wav");
        }
    }

   
    private void checkCollision()
    {
        if(isTouching(Gas.class))
        {
            removeTouching(Gas.class);       
            Greenfoot.playSound("boom.wav");
            Road Road = (Road)getWorld();
            Road.addScore(20);
        }
        if(isTouching(Truck.class))
        {
            removeTouching(Truck.class);
            Road Road = (Road)getWorld();
            Road.addScore(-100);
            Greenfoot.playSound("meh.wav");
            
        }
    }
}
