import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The Road is the setting for our White Blood Cell scenario. 
 * It's a place where blood cells, Gas and Truckes float around.
 * 
 * @author Michael Kölling
 * @version 0.1
 */
public class Road extends World
{
    private int score;
    private int time;
    
    /**
     * Constructor: Set up the staring objects.
     */
    public Road()
    {    
        super(780, 360, 1); 
        GreenfootImage bg = new GreenfootImage("op road a1.jpg");
        bg.scale(getWidth(), getHeight());
        setBackground(bg);
        setPaintOrder(Spotlight.class);
        prepare();
        score = 0;
        time = 2000;
    }

    /**
     * Create new floating objects at irregular intervals.
     */
    public void act()
    {
        showScore();
        showTime();
        countTime();
        
        if (Greenfoot.getRandomNumber(100) < 3)
        {
            addObject(new Gas(), 779, Greenfoot.getRandomNumber(360));
        }
        if (Greenfoot.getRandomNumber(100) < 1)
        {
            addObject(new GuardRailTop(), 779, 359);
            
        }if (Greenfoot.getRandomNumber(100) < 1)
        {
            addObject(new GuardRailBottom(), 779, 0);
        }
        if (Greenfoot.getRandomNumber(100) < 1)
        {
            addObject(new Truck(), 779, Greenfoot.getRandomNumber(359));
        }
        if (Greenfoot.getRandomNumber(100) < 6)
        {
            addObject(new Wind(), 779, Greenfoot.getRandomNumber(359));

        }
    }

    /**
     * Shows score on the screen while the game runs.
     */
    public void addScore(int points)
    {
        score = score + points;
        showScore();
        if (score <0)
        {
            Greenfoot.stop();
            Greenfoot.playSound("Siren.wav");
        }
    }

    private void countTime()
    {
        time--;
        showTime();
        if (time == 0)
        {
            showEndMessage();
            Greenfoot.stop();
        }
    }

    private void showEndMessage()
    {
        showText("Time is up - you win!", 390, 150);
        showText("Your final score: " + score + " points", 390, 170);
    }

    private void showTime()
    {
        showText("Time: " + time, 650, 25);
    }

    private void showScore()
    {
        showText("Score: " + score, 80, 25);
    }

    /**
     * Prepare the world for the start of the program. In this case: Create
     * a white blood cell and the lining at the edge of the blood stream.
     */
    private void prepare()
    {

        Lambo lambo = new Lambo();
        addObject(lambo,193,194);
        GuardRailTop guardrailtop = new GuardRailTop();
        addObject(guardrailtop,397,30);
        guardrailtop.setLocation(398,25);
        GuardRailTop guardrailtop2 = new GuardRailTop();
        addObject(guardrailtop2,398,342);
        Spotlight spotlight = new Spotlight();
        addObject(spotlight,758,186);
        spotlight.setLocation(760,180);
        Spotlight spotlight2 = new Spotlight();
        addObject(spotlight2,24,187);
        spotlight2.setLocation(25,179);
        spotlight2.setLocation(24,180);
        lambo.setLocation(240,193);
        Cop cop = new Cop();
        addObject(cop,104,189);
        lambo.setLocation(281,192);
        cop.setLocation(124,181);
    }
}
